*** a/src/backend/executor/nodeAgg.c
--- b/src/backend/executor/nodeAgg.c
***************
*** 1822,1871 **** ExecInitAgg(Agg *node, EState *estate, int eflags)
  				(AttrNumber *) palloc(numSortCols * sizeof(AttrNumber));
  			peraggstate->sortOperators =
  				(Oid *) palloc(numSortCols * sizeof(Oid));
  			peraggstate->sortCollations =
  				(Oid *) palloc(numSortCols * sizeof(Oid));
  			peraggstate->sortNullsFirst =
  				(bool *) palloc(numSortCols * sizeof(bool));
  
  			i = 0;
  			foreach(lc, sortlist)
  			{
  				SortGroupClause *sortcl = (SortGroupClause *) lfirst(lc);
  				TargetEntry *tle = get_sortgroupclause_tle(sortcl,
! 														   aggref->args);
  
  				/* the parser should have made sure of this */
  				Assert(OidIsValid(sortcl->sortop));
  
  				peraggstate->sortColIdx[i] = tle->resno;
  				peraggstate->sortOperators[i] = sortcl->sortop;
  				peraggstate->sortCollations[i] = exprCollation((Node *) tle->expr);
  				peraggstate->sortNullsFirst[i] = sortcl->nulls_first;
- 				i++;
- 			}
- 			Assert(i == numSortCols);
- 		}
  
! 		if (aggref->aggdistinct)
! 		{
! 			Assert(numArguments > 0);
! 
! 			/*
! 			 * We need the equal function for each DISTINCT comparison we will
! 			 * make.
! 			 */
! 			peraggstate->equalfns =
! 				(FmgrInfo *) palloc(numDistinctCols * sizeof(FmgrInfo));
! 
! 			i = 0;
! 			foreach(lc, aggref->aggdistinct)
! 			{
! 				SortGroupClause *sortcl = (SortGroupClause *) lfirst(lc);
  
- 				fmgr_info(get_opcode(sortcl->eqop), &peraggstate->equalfns[i]);
  				i++;
  			}
! 			Assert(i == numDistinctCols);
  		}
  
  		ReleaseSysCache(aggTuple);
--- 2090,2136 ----
  				(AttrNumber *) palloc(numSortCols * sizeof(AttrNumber));
  			peraggstate->sortOperators =
  				(Oid *) palloc(numSortCols * sizeof(Oid));
+ 			peraggstate->sortEqOperators =
+ 				(Oid *) palloc(numSortCols * sizeof(Oid));
  			peraggstate->sortCollations =
  				(Oid *) palloc(numSortCols * sizeof(Oid));
  			peraggstate->sortNullsFirst =
  				(bool *) palloc(numSortCols * sizeof(bool));
+ 			if (numDistinctCols > 0)
+ 				peraggstate->equalfns =
+ 					(FmgrInfo *) palloc(numDistinctCols * sizeof(FmgrInfo));
+ 			else
+ 				peraggstate->equalfns = NULL;
+ 			
  
  			i = 0;
  			foreach(lc, sortlist)
  			{
  				SortGroupClause *sortcl = (SortGroupClause *) lfirst(lc);
  				TargetEntry *tle = get_sortgroupclause_tle(sortcl,
! 														   argexprs);
  
  				/* the parser should have made sure of this */
  				Assert(OidIsValid(sortcl->sortop));
  
  				peraggstate->sortColIdx[i] = tle->resno;
  				peraggstate->sortOperators[i] = sortcl->sortop;
+ 				peraggstate->sortEqOperators[i] = sortcl->eqop;
  				peraggstate->sortCollations[i] = exprCollation((Node *) tle->expr);
  				peraggstate->sortNullsFirst[i] = sortcl->nulls_first;
  
! 				/*
! 				 * It's OK to get the equalfns here too, since we already
! 				 * require that sortlist is aggref->aggdistinct for the normal
! 				 * distinct case, and for ordered set functions using the
! 				 * (possibly modified copy of) aggref->aggorder is correct
! 				 */
! 				if (peraggstate->equalfns)
! 					fmgr_info(get_opcode(sortcl->eqop), &peraggstate->equalfns[i]);
  
  				i++;
  			}
! 			Assert(i == numSortCols);
  		}
  
  		ReleaseSysCache(aggTuple);
***************
*** 2023,2028 **** ExecReScanAgg(AggState *node)
--- 2288,2296 ----
   * If aggcontext isn't NULL, the function also stores at *aggcontext the
   * identity of the memory context that aggregate transition values are
   * being stored in.
+  *
+  * We do NOT include AGG_CONTEXT_ORDERED as a possible return here, since
+  * that would open a security hole.
   */
  int
  AggCheckCallContext(FunctionCallInfo fcinfo, MemoryContext *aggcontext)
***************
*** 2063,2065 **** aggregate_dummy(PG_FUNCTION_ARGS)
--- 2331,2448 ----
  		 fcinfo->flinfo->fn_oid);
  	return (Datum) 0;			/* keep compiler quiet */
  }
+ 
+ /* AggSetGetRowCount - Get the number of rows in case of ordered set
+  * functions.
+  */
+ int64
+ AggSetGetRowCount(FunctionCallInfo fcinfo)
+ {
+ 	if (fcinfo->context && IsA(fcinfo->context, AggStatePerAggData))
+ 	{
+ 		return ((AggStatePerAggData *)fcinfo->context)->number_of_rows;
+ 	}
+ 
+ 	elog(ERROR, "Called AggSetGetRowCount on non ordered set function");
+ 	return -1;
+ }
+ 
+ /* AggSetGetSortInfo - Get the sort state in the case of 
+  * ordered set functions.
+  */
+ void
+ AggSetGetSortInfo(FunctionCallInfo fcinfo,
+ 				  Tuplesortstate **sortstate,
+ 				  TupleDesc *tupdesc,
+ 				  TupleTableSlot **tupslot,
+ 				  Oid *datumtype)
+ {
+ 	if (fcinfo->context && IsA(fcinfo->context, AggStatePerAggData))
+ 	{
+ 		AggStatePerAggData *peraggstate = (AggStatePerAggData *) fcinfo->context;
+ 
+ 		*sortstate = peraggstate->sortstate;
+ 		if (peraggstate->numInputs == 1)
+ 		{
+ 			if (tupdesc)
+ 				*tupdesc = NULL;
+ 			if (datumtype)
+ 				*datumtype = peraggstate->evaldesc->attrs[0]->atttypid;
+ 		}
+ 		else
+ 		{
+ 			if (tupdesc)
+ 				*tupdesc = peraggstate->evaldesc;
+ 			if (datumtype)
+ 				*datumtype = InvalidOid;
+ 		}
+ 		
+ 		if (tupslot)
+ 			*tupslot = peraggstate->evalslot;
+ 	}
+ 	else
+ 		elog(ERROR, "AggSetSortInfo called on non ordered set function");
+ }
+ 
+ int
+ AggSetGetDistinctInfo(FunctionCallInfo fcinfo,
+ 					  TupleTableSlot **uniqslot,
+ 					  AttrNumber **sortColIdx,
+ 					  FmgrInfo **equalfns)
+ {
+ 	if (fcinfo->context && IsA(fcinfo->context, AggStatePerAggData))
+ 	{
+ 		AggStatePerAggData *peraggstate = (AggStatePerAggData *) fcinfo->context;
+ 
+ 		if (uniqslot)
+ 			*uniqslot = peraggstate->uniqslot;
+ 		if (sortColIdx)
+ 			*sortColIdx = peraggstate->sortColIdx;
+ 		if (equalfns)
+ 			*equalfns = peraggstate->equalfns;
+ 
+ 		return peraggstate->numDistinctCols;
+ 	}
+ 	else
+ 		elog(ERROR, "AggSetGetDistinctOperators called on non ordered set function");
+ }
+ 
+ int
+ AggSetGetSortOperators(FunctionCallInfo fcinfo,
+ 					   AttrNumber **sortColIdx,
+ 					   Oid **sortOperators,
+ 					   Oid **sortEqOperators,
+ 					   Oid **sortCollations,
+ 					   bool **sortNullsFirst)
+ {
+ 	if (fcinfo->context && IsA(fcinfo->context, AggStatePerAggData))
+ 	{
+ 		AggStatePerAggData *peraggstate = (AggStatePerAggData *) fcinfo->context;
+ 
+ 		if (sortColIdx)
+ 			*sortColIdx = peraggstate->sortColIdx;
+ 		if (sortOperators)
+ 			*sortOperators = peraggstate->sortOperators;
+ 		if (sortEqOperators)
+ 			*sortEqOperators = peraggstate->sortEqOperators;
+ 		if (sortCollations)
+ 			*sortCollations = peraggstate->sortCollations;
+ 		if (sortNullsFirst)
+ 			*sortNullsFirst = peraggstate->sortNullsFirst;
+ 
+ 		return peraggstate->numSortCols;
+ 	}
+ 	else
+ 		elog(ERROR, "AggSetGetSortOperators called on non ordered set function");
+ }
+ 
+ void
+ AggSetGetPerTupleContext(FunctionCallInfo fcinfo,
+ 						 MemoryContext *memcontext)
+ {
+ 	if (fcinfo->context && IsA(fcinfo->context, AggStatePerAggData))
+ 	{
+ 		AggStatePerAggData *peraggstate = (AggStatePerAggData *) fcinfo->context;
+ 		*memcontext = peraggstate->aggstate->tmpcontext->ecxt_per_tuple_memory;
+ 	}
+ }
*** a/src/backend/nodes/copyfuncs.c
--- b/src/backend/nodes/copyfuncs.c
***************
*** 1139,1147 **** _copyAggref(const Aggref *from)
--- 1139,1150 ----
  	COPY_NODE_FIELD(args);
  	COPY_NODE_FIELD(aggorder);
  	COPY_NODE_FIELD(aggdistinct);
+ 	COPY_NODE_FIELD(orddirectargs);
  	COPY_NODE_FIELD(aggfilter);
  	COPY_SCALAR_FIELD(aggstar);
  	COPY_SCALAR_FIELD(aggvariadic);
+ 	COPY_SCALAR_FIELD(isordset);
+ 	COPY_SCALAR_FIELD(ishypothetical);
  	COPY_SCALAR_FIELD(agglevelsup);
  	COPY_LOCATION_FIELD(location);
  
***************
*** 2174,2179 **** _copyFuncCall(const FuncCall *from)
--- 2177,2183 ----
  	COPY_SCALAR_FIELD(agg_star);
  	COPY_SCALAR_FIELD(agg_distinct);
  	COPY_SCALAR_FIELD(func_variadic);
+ 	COPY_SCALAR_FIELD(has_within_group);
  	COPY_NODE_FIELD(over);
  	COPY_LOCATION_FIELD(location);
  
*** a/src/backend/nodes/equalfuncs.c
--- b/src/backend/nodes/equalfuncs.c
***************
*** 196,204 **** _equalAggref(const Aggref *a, const Aggref *b)
--- 196,207 ----
  	COMPARE_NODE_FIELD(args);
  	COMPARE_NODE_FIELD(aggorder);
  	COMPARE_NODE_FIELD(aggdistinct);
+ 	COMPARE_NODE_FIELD(orddirectargs);
  	COMPARE_NODE_FIELD(aggfilter);
  	COMPARE_SCALAR_FIELD(aggstar);
  	COMPARE_SCALAR_FIELD(aggvariadic);
+ 	COMPARE_SCALAR_FIELD(isordset);
+ 	COMPARE_SCALAR_FIELD(ishypothetical);
  	COMPARE_SCALAR_FIELD(agglevelsup);
  	COMPARE_LOCATION_FIELD(location);
  
***************
*** 2006,2011 **** _equalFuncCall(const FuncCall *a, const FuncCall *b)
--- 2009,2015 ----
  	COMPARE_SCALAR_FIELD(agg_star);
  	COMPARE_SCALAR_FIELD(agg_distinct);
  	COMPARE_SCALAR_FIELD(func_variadic);
+ 	COMPARE_SCALAR_FIELD(has_within_group);
  	COMPARE_NODE_FIELD(over);
  	COMPARE_LOCATION_FIELD(location);
  
*** a/src/backend/nodes/makefuncs.c
--- b/src/backend/nodes/makefuncs.c
***************
*** 558,563 **** makeFuncCall(List *name, List *args, int location)
--- 558,564 ----
  	n->agg_star = FALSE;
  	n->agg_distinct = FALSE;
  	n->func_variadic = FALSE;
+ 	n->has_within_group = FALSE;
  	n->over = NULL;
  	return n;
  }
*** a/src/backend/nodes/nodeFuncs.c
--- b/src/backend/nodes/nodeFuncs.c
***************
*** 1631,1636 **** expression_tree_walker(Node *node,
--- 1631,1641 ----
  				if (expression_tree_walker((Node *) expr->aggdistinct,
  										   walker, context))
  					return true;
+ 
+ 				if (expression_tree_walker((Node *) expr->orddirectargs,
+ 										   walker, context))
+ 					return true;
+ 
  				if (walker((Node *) expr->aggfilter, context))
  					return true;
  			}
***************
*** 2155,2161 **** expression_tree_mutator(Node *node,
--- 2160,2168 ----
  				MUTATE(newnode->args, aggref->args, List *);
  				MUTATE(newnode->aggorder, aggref->aggorder, List *);
  				MUTATE(newnode->aggdistinct, aggref->aggdistinct, List *);
+ 				MUTATE(newnode->orddirectargs, aggref->orddirectargs, List *);
  				MUTATE(newnode->aggfilter, aggref->aggfilter, Expr *);
+ 
  				return (Node *) newnode;
  			}
  			break;
*** a/src/backend/nodes/outfuncs.c
--- b/src/backend/nodes/outfuncs.c
***************
*** 960,968 **** _outAggref(StringInfo str, const Aggref *node)
--- 960,971 ----
  	WRITE_NODE_FIELD(args);
  	WRITE_NODE_FIELD(aggorder);
  	WRITE_NODE_FIELD(aggdistinct);
+ 	WRITE_NODE_FIELD(orddirectargs);
  	WRITE_NODE_FIELD(aggfilter);
  	WRITE_BOOL_FIELD(aggstar);
  	WRITE_BOOL_FIELD(aggvariadic);
+ 	WRITE_BOOL_FIELD(isordset);
+ 	WRITE_BOOL_FIELD(ishypothetical);
  	WRITE_UINT_FIELD(agglevelsup);
  	WRITE_LOCATION_FIELD(location);
  }
***************
*** 2090,2095 **** _outFuncCall(StringInfo str, const FuncCall *node)
--- 2093,2099 ----
  	WRITE_BOOL_FIELD(agg_star);
  	WRITE_BOOL_FIELD(agg_distinct);
  	WRITE_BOOL_FIELD(func_variadic);
+ 	WRITE_BOOL_FIELD(has_within_group);
  	WRITE_NODE_FIELD(over);
  	WRITE_LOCATION_FIELD(location);
  }
*** a/src/backend/nodes/readfuncs.c
--- b/src/backend/nodes/readfuncs.c
***************
*** 495,503 **** _readAggref(void)
--- 495,506 ----
  	READ_NODE_FIELD(args);
  	READ_NODE_FIELD(aggorder);
  	READ_NODE_FIELD(aggdistinct);
+ 	READ_NODE_FIELD(orddirectargs);
  	READ_NODE_FIELD(aggfilter);
  	READ_BOOL_FIELD(aggstar);
  	READ_BOOL_FIELD(aggvariadic);
+ 	READ_BOOL_FIELD(isordset);
+ 	READ_BOOL_FIELD(ishypothetical);
  	READ_UINT_FIELD(agglevelsup);
  	READ_LOCATION_FIELD(location);
  
*** a/src/backend/optimizer/util/clauses.c
--- b/src/backend/optimizer/util/clauses.c
***************
*** 39,44 ****
--- 39,45 ----
  #include "parser/analyze.h"
  #include "parser/parse_coerce.h"
  #include "parser/parse_func.h"
+ #include "parser/parse_agg.h"
  #include "rewrite/rewriteManip.h"
  #include "tcop/tcopprot.h"
  #include "utils/acl.h"
***************
*** 464,470 **** count_agg_clauses_walker(Node *node, count_agg_clauses_context *context)
  		QualCost	argcosts;
  		Oid		   *inputTypes;
  		int			numArguments;
- 		ListCell   *l;
  
  		Assert(aggref->agglevelsup == 0);
  
--- 465,470 ----
***************
*** 486,492 **** count_agg_clauses_walker(Node *node, count_agg_clauses_context *context)
  			costs->numOrderedAggs++;
  
  		/* add component function execution costs to appropriate totals */
! 		costs->transCost.per_tuple += get_func_cost(aggtransfn) * cpu_operator_cost;
  		if (OidIsValid(aggfinalfn))
  			costs->finalCost += get_func_cost(aggfinalfn) * cpu_operator_cost;
  
--- 486,493 ----
  			costs->numOrderedAggs++;
  
  		/* add component function execution costs to appropriate totals */
! 		if (OidIsValid(aggtransfn))
! 			costs->transCost.per_tuple += get_func_cost(aggtransfn) * cpu_operator_cost;
  		if (OidIsValid(aggfinalfn))
  			costs->finalCost += get_func_cost(aggfinalfn) * cpu_operator_cost;
  
***************
*** 504,575 **** count_agg_clauses_walker(Node *node, count_agg_clauses_context *context)
  		costs->transCost.startup += argcosts.startup;
  		costs->transCost.per_tuple += argcosts.per_tuple;
  
! 		/* extract argument types (ignoring any ORDER BY expressions) */
! 		inputTypes = (Oid *) palloc(sizeof(Oid) * list_length(aggref->args));
! 		numArguments = 0;
! 		foreach(l, aggref->args)
  		{
! 			TargetEntry *tle = (TargetEntry *) lfirst(l);
  
! 			if (!tle->resjunk)
! 				inputTypes[numArguments++] = exprType((Node *) tle->expr);
! 		}
  
! 		/* resolve actual type of transition state, if polymorphic */
! 		if (IsPolymorphicType(aggtranstype))
! 		{
! 			/* have to fetch the agg's declared input types... */
! 			Oid		   *declaredArgTypes;
! 			int			agg_nargs;
! 
! 			(void) get_func_signature(aggref->aggfnoid,
! 									  &declaredArgTypes, &agg_nargs);
! 			Assert(agg_nargs == numArguments);
! 			aggtranstype = enforce_generic_type_consistency(inputTypes,
! 															declaredArgTypes,
! 															agg_nargs,
! 															aggtranstype,
! 															false);
! 			pfree(declaredArgTypes);
! 		}
  
! 		/*
! 		 * If the transition type is pass-by-value then it doesn't add
! 		 * anything to the required size of the hashtable.	If it is
! 		 * pass-by-reference then we have to add the estimated size of the
! 		 * value itself, plus palloc overhead.
! 		 */
! 		if (!get_typbyval(aggtranstype))
! 		{
! 			int32		aggtranstypmod;
! 			int32		avgwidth;
  
  			/*
! 			 * If transition state is of same type as first input, assume it's
! 			 * the same typmod (same width) as well.  This works for cases
! 			 * like MAX/MIN and is probably somewhat reasonable otherwise.
  			 */
! 			if (numArguments > 0 && aggtranstype == inputTypes[0])
! 				aggtranstypmod = exprTypmod((Node *) linitial(aggref->args));
! 			else
! 				aggtranstypmod = -1;
  
! 			avgwidth = get_typavgwidth(aggtranstype, aggtranstypmod);
! 			avgwidth = MAXALIGN(avgwidth);
  
! 			costs->transitionSpace += avgwidth + 2 * sizeof(void *);
  		}
! 		else if (aggtranstype == INTERNALOID)
  		{
! 			/*
! 			 * INTERNAL transition type is a special case: although INTERNAL
! 			 * is pass-by-value, it's almost certainly being used as a pointer
! 			 * to some large data structure.  We assume usage of
! 			 * ALLOCSET_DEFAULT_INITSIZE, which is a good guess if the data is
! 			 * being kept in a private memory context, as is done by
! 			 * array_agg() for instance.
! 			 */
! 			costs->transitionSpace += ALLOCSET_DEFAULT_INITSIZE;
  		}
  
  		/*
--- 505,595 ----
  		costs->transCost.startup += argcosts.startup;
  		costs->transCost.per_tuple += argcosts.per_tuple;
  
! 		/*
! 		 * If we're doing a sorted agg, we can punt the entire
! 		 * determination of transition element size since we're not
! 		 * going to be using it to determine hashtable limits. This
! 		 * simplifies the code for hypothetical set functions.
! 		 */
! 
! 		if (aggref->aggorder == NIL && aggref->aggdistinct == NIL)
  		{
! 			Assert(!aggref->isordset);
  
! 			/* extract argument types (ignoring any ORDER BY expressions) */
! 			inputTypes = (Oid *) palloc(sizeof(Oid) * FUNC_MAX_ARGS);
  
! 			numArguments = get_aggregate_argtypes(aggref, inputTypes, NULL);
  
! 			/* resolve actual type of transition state, if polymorphic */
! 			if (OidIsValid(aggtranstype) && IsPolymorphicType(aggtranstype))
! 			{
! 				/* have to fetch the agg's declared input types... */
! 				Oid		   *declaredArgTypes;
! 				int			agg_nargs;
! 
! 				(void) get_func_signature(aggref->aggfnoid,
! 										  &declaredArgTypes, &agg_nargs);
! 
! 				/*
! 				 * if variadic "any", might be more actual args than declared
! 				 * args, but these extra args can't influence the determination
! 				 * of polymorphic transition or result type.
! 				 */
! 				Assert(agg_nargs <= numArguments);
! 
! 				aggtranstype = enforce_generic_type_consistency(inputTypes,
! 																declaredArgTypes,
! 																agg_nargs,
! 																aggtranstype,
! 																false);
! 				pfree(declaredArgTypes);
! 			}
  
  			/*
! 			 * If the transition type is pass-by-value then it doesn't add
! 			 * anything to the required size of the hashtable.	If it is
! 			 * pass-by-reference then we have to add the estimated size of the
! 			 * value itself, plus palloc overhead.
  			 */
! 			if (OidIsValid(aggtranstype) && !get_typbyval(aggtranstype))
! 			{
! 				int32		aggtranstypmod;
! 				int32		avgwidth;
! 
! 				/*
! 				 * If transition state is of same type as first input, assume it's
! 				 * the same typmod (same width) as well.  This works for cases
! 				 * like MAX/MIN and is probably somewhat reasonable otherwise.
! 				 */
! 				if (numArguments > 0 && aggtranstype == inputTypes[0])
! 					aggtranstypmod = exprTypmod((Node *) linitial(aggref->args));
! 				else
! 					aggtranstypmod = -1;
  
! 				avgwidth = get_typavgwidth(aggtranstype, aggtranstypmod);
! 				avgwidth = MAXALIGN(avgwidth);
  
! 				costs->transitionSpace += avgwidth + 2 * sizeof(void *);
! 			}
! 			else if (aggtranstype == INTERNALOID)
! 			{
! 				/*
! 				 * INTERNAL transition type is a special case: although INTERNAL
! 				 * is pass-by-value, it's almost certainly being used as a pointer
! 				 * to some large data structure.  We assume usage of
! 				 * ALLOCSET_DEFAULT_INITSIZE, which is a good guess if the data is
! 				 * being kept in a private memory context, as is done by
! 				 * array_agg() for instance.
! 				 */
! 				costs->transitionSpace += ALLOCSET_DEFAULT_INITSIZE;
! 			}
! 
! 			pfree(inputTypes);
  		}
! 		else
  		{
! 			costs->transitionSpace = work_mem;   /* just in case */
  		}
  
  		/*
***************
*** 3826,3832 **** recheck_cast_function_args(List *args, Oid result_type, HeapTuple func_tuple)
  		elog(ERROR, "function's resolved result type changed during planning");
  
  	/* perform any necessary typecasting of arguments */
! 	make_fn_arguments(NULL, args, actual_arg_types, declared_arg_types);
  }
  
  /*
--- 3846,3852 ----
  		elog(ERROR, "function's resolved result type changed during planning");
  
  	/* perform any necessary typecasting of arguments */
! 	make_fn_arguments(NULL, args, NULL, actual_arg_types, declared_arg_types, false);
  }
  
  /*
*** a/src/backend/parser/analyze.c
--- b/src/backend/parser/analyze.c
***************
*** 951,957 **** transformSelectStmt(ParseState *pstate, SelectStmt *stmt)
  										  &qry->targetList,
  										  EXPR_KIND_ORDER_BY,
  										  true /* fix unknowns */ ,
! 										  false /* allow SQL92 rules */ );
  
  	qry->groupClause = transformGroupClause(pstate,
  											stmt->groupClause,
--- 951,958 ----
  										  &qry->targetList,
  										  EXPR_KIND_ORDER_BY,
  										  true /* fix unknowns */ ,
! 										  false /* allow SQL92 rules */,
! 										  false /* don't add duplicates */);
  
  	qry->groupClause = transformGroupClause(pstate,
  											stmt->groupClause,
***************
*** 1211,1217 **** transformValuesClause(ParseState *pstate, SelectStmt *stmt)
  										  &qry->targetList,
  										  EXPR_KIND_ORDER_BY,
  										  true /* fix unknowns */ ,
! 										  false /* allow SQL92 rules */ );
  
  	qry->limitOffset = transformLimitClause(pstate, stmt->limitOffset,
  											EXPR_KIND_OFFSET, "OFFSET");
--- 1212,1219 ----
  										  &qry->targetList,
  										  EXPR_KIND_ORDER_BY,
  										  true /* fix unknowns */ ,
! 										  false /* allow SQL92 rules */,
! 										  false /* don't add duplicates */ );
  
  	qry->limitOffset = transformLimitClause(pstate, stmt->limitOffset,
  											EXPR_KIND_OFFSET, "OFFSET");
***************
*** 1435,1441 **** transformSetOperationStmt(ParseState *pstate, SelectStmt *stmt)
  										  &qry->targetList,
  										  EXPR_KIND_ORDER_BY,
  										  false /* no unknowns expected */ ,
! 										  false /* allow SQL92 rules */ );
  
  	/* restore namespace, remove jrte from rtable */
  	pstate->p_namespace = sv_namespace;
--- 1437,1444 ----
  										  &qry->targetList,
  										  EXPR_KIND_ORDER_BY,
  										  false /* no unknowns expected */ ,
! 										  false /* allow SQL92 rules */ ,
! 										  false /* don't add duplicates */ );
  
  	/* restore namespace, remove jrte from rtable */
  	pstate->p_namespace = sv_namespace;
*** a/src/backend/parser/gram.y
--- b/src/backend/parser/gram.y
***************
*** 494,499 **** static Node *makeRecursiveViewSelect(char *relname, List *aliases, Node *query);
--- 494,500 ----
  %type <str>		opt_existing_window_name
  %type <boolean> opt_if_not_exists
  %type <node>    filter_clause
+ %type <list> 	within_group_clause
  
  /*
   * Non-keyword token types.  These are hard-wired into the "flex" lexer.
***************
*** 596,602 **** static Node *makeRecursiveViewSelect(char *relname, List *aliases, Node *query);
  	VACUUM VALID VALIDATE VALIDATOR VALUE_P VALUES VARCHAR VARIADIC VARYING
  	VERBOSE VERSION_P VIEW VOLATILE
  
! 	WHEN WHERE WHITESPACE_P WINDOW WITH WITHOUT WORK WRAPPER WRITE
  
  	XML_P XMLATTRIBUTES XMLCONCAT XMLELEMENT XMLEXISTS XMLFOREST XMLPARSE
  	XMLPI XMLROOT XMLSERIALIZE
--- 597,603 ----
  	VACUUM VALID VALIDATE VALIDATOR VALUE_P VALUES VARCHAR VARIADIC VARYING
  	VERBOSE VERSION_P VIEW VOLATILE
  
! 	WHEN WHERE WITHIN WHITESPACE_P WINDOW WITH WITHOUT WORK WRAPPER WRITE
  
  	XML_P XMLATTRIBUTES XMLCONCAT XMLELEMENT XMLEXISTS XMLFOREST XMLPARSE
  	XMLPI XMLROOT XMLSERIALIZE
***************
*** 3660,3666 **** AlterExtensionContentsStmt:
  					n->action = $4;
  					n->objtype = OBJECT_AGGREGATE;
  					n->objname = $6;
! 					n->objargs = extractArgTypes($7);
  					$$ = (Node *)n;
  				}
  			| ALTER EXTENSION name add_drop CAST '(' Typename AS Typename ')'
--- 3661,3667 ----
  					n->action = $4;
  					n->objtype = OBJECT_AGGREGATE;
  					n->objname = $6;
! 					n->objargs = extractArgTypes(linitial($7));
  					$$ = (Node *)n;
  				}
  			| ALTER EXTENSION name add_drop CAST '(' Typename AS Typename ')'
***************
*** 5239,5245 **** CommentStmt:
  					CommentStmt *n = makeNode(CommentStmt);
  					n->objtype = OBJECT_AGGREGATE;
  					n->objname = $4;
! 					n->objargs = extractArgTypes($5);
  					n->comment = $7;
  					$$ = (Node *) n;
  				}
--- 5240,5246 ----
  					CommentStmt *n = makeNode(CommentStmt);
  					n->objtype = OBJECT_AGGREGATE;
  					n->objname = $4;
! 					n->objargs = extractArgTypes(linitial($5));
  					n->comment = $7;
  					$$ = (Node *) n;
  				}
***************
*** 5405,5411 **** SecLabelStmt:
  					n->provider = $3;
  					n->objtype = OBJECT_AGGREGATE;
  					n->objname = $6;
! 					n->objargs = extractArgTypes($7);
  					n->label = $9;
  					$$ = (Node *) n;
  				}
--- 5406,5412 ----
  					n->provider = $3;
  					n->objtype = OBJECT_AGGREGATE;
  					n->objname = $6;
! 					n->objargs = extractArgTypes(linitial($7));
  					n->label = $9;
  					$$ = (Node *) n;
  				}
***************
*** 6405,6413 **** aggr_arg:	func_arg
  				}
  		;
  
! /* Zero-argument aggregates are named with * for consistency with COUNT(*) */
! aggr_args:	'(' aggr_args_list ')'					{ $$ = $2; }
! 			| '(' '*' ')'							{ $$ = NIL; }
  		;
  
  aggr_args_list:
--- 6406,6458 ----
  				}
  		;
  
! /*
!  * Aggregate args (for create aggregate, etc.) are treated as follows:
!  *
!  * (*)                              - no args
!  * (func_arg,func_arg,...)          - normal agg with args
!  * () within group (func_arg,...)   - ordered set func with no direct args
!  * (func_arg,...) within group (func_arg,...)  - ordered set func with args
!  * (func_arg,...) within group (*)  - ordered set func variadic special case
!  *
!  * This doesn't correspond to anything in the spec because the spec doesn't
!  * have any DDL to create or modify ordered set functions, so we're winging
!  * it here.
!  *
!  * Almost everything we do with an ordered set function treats its arguments
!  * as though they were a single list, with the direct and grouped arg types
!  * concatenated. So for simplicity, we construct a single list here.
!  *
!  * But we still need to know when creating an agg (but not for referring to it
!  * later) where the division between direct and ordered args is; so this
!  * production returns a pair (arglist,num) where num is the number of direct
!  * args, or -1 if no within group clause was used. Most users of aggr_args,
!  * other than CREATE AGGREGATE, therefore only need to pay attention to
!  * linitial($n).
!  */
! 
! aggr_args:  '(' '*' ')'
! 				{
! 					$$ = list_make2(NIL, makeInteger(-1));
! 				}
! 			| '(' aggr_args_list ')'
! 				{
! 					$$ = list_make2($2, makeInteger(-1));
! 				}
! 			| '(' ')' WITHIN GROUP_P '(' aggr_args_list ')'
! 				{
! 					$$ = list_make2($6, makeInteger(0));
! 				}
! 			| '(' aggr_args_list ')' WITHIN GROUP_P '(' aggr_args_list ')'
! 				{
! 					int n = list_length($2);
! 					$$ = list_make2(list_concat($2,$7), makeInteger(n));
! 				}
! 			| '(' aggr_args_list ')' WITHIN GROUP_P '(' '*' ')'
! 				{
! 					int n = list_length($2);
! 					$$ = list_make2($2, makeInteger(n));
! 				}
  		;
  
  aggr_args_list:
***************
*** 6613,6619 **** RemoveAggrStmt:
  					DropStmt *n = makeNode(DropStmt);
  					n->removeType = OBJECT_AGGREGATE;
  					n->objects = list_make1($3);
! 					n->arguments = list_make1(extractArgTypes($4));
  					n->behavior = $5;
  					n->missing_ok = false;
  					n->concurrent = false;
--- 6658,6664 ----
  					DropStmt *n = makeNode(DropStmt);
  					n->removeType = OBJECT_AGGREGATE;
  					n->objects = list_make1($3);
! 					n->arguments = list_make1(extractArgTypes(linitial($4)));
  					n->behavior = $5;
  					n->missing_ok = false;
  					n->concurrent = false;
***************
*** 6624,6630 **** RemoveAggrStmt:
  					DropStmt *n = makeNode(DropStmt);
  					n->removeType = OBJECT_AGGREGATE;
  					n->objects = list_make1($5);
! 					n->arguments = list_make1(extractArgTypes($6));
  					n->behavior = $7;
  					n->missing_ok = true;
  					n->concurrent = false;
--- 6669,6675 ----
  					DropStmt *n = makeNode(DropStmt);
  					n->removeType = OBJECT_AGGREGATE;
  					n->objects = list_make1($5);
! 					n->arguments = list_make1(extractArgTypes(linitial($6)));
  					n->behavior = $7;
  					n->missing_ok = true;
  					n->concurrent = false;
***************
*** 6840,6846 **** RenameStmt: ALTER AGGREGATE func_name aggr_args RENAME TO name
  					RenameStmt *n = makeNode(RenameStmt);
  					n->renameType = OBJECT_AGGREGATE;
  					n->object = $3;
! 					n->objarg = extractArgTypes($4);
  					n->newname = $7;
  					n->missing_ok = false;
  					$$ = (Node *)n;
--- 6885,6891 ----
  					RenameStmt *n = makeNode(RenameStmt);
  					n->renameType = OBJECT_AGGREGATE;
  					n->object = $3;
! 					n->objarg = extractArgTypes(linitial($4));
  					n->newname = $7;
  					n->missing_ok = false;
  					$$ = (Node *)n;
***************
*** 7314,7320 **** AlterObjectSchemaStmt:
  					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
  					n->objectType = OBJECT_AGGREGATE;
  					n->object = $3;
! 					n->objarg = extractArgTypes($4);
  					n->newschema = $7;
  					n->missing_ok = false;
  					$$ = (Node *)n;
--- 7359,7365 ----
  					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
  					n->objectType = OBJECT_AGGREGATE;
  					n->object = $3;
! 					n->objarg = extractArgTypes(linitial($4));
  					n->newschema = $7;
  					n->missing_ok = false;
  					$$ = (Node *)n;
***************
*** 7543,7549 **** AlterOwnerStmt: ALTER AGGREGATE func_name aggr_args OWNER TO RoleId
  					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
  					n->objectType = OBJECT_AGGREGATE;
  					n->object = $3;
! 					n->objarg = extractArgTypes($4);
  					n->newowner = $7;
  					$$ = (Node *)n;
  				}
--- 7588,7594 ----
  					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
  					n->objectType = OBJECT_AGGREGATE;
  					n->object = $3;
! 					n->objarg = extractArgTypes(linitial($4));
  					n->newowner = $7;
  					$$ = (Node *)n;
  				}
***************
*** 9431,9436 **** sortby:		a_expr USING qual_all_Op opt_nulls_order
--- 9476,9486 ----
  		;
  
  
+ within_group_clause:
+ 			WITHIN GROUP_P '(' sort_clause ')'  { $$ = $4; }
+ 			| /*EMPTY*/                         { $$ = NIL; }
+          ;
+ 
  select_limit:
  			limit_clause offset_clause			{ $$ = list_make2($2, $1); }
  			| offset_clause limit_clause		{ $$ = list_make2($1, $2); }
***************
*** 11152,11163 **** func_application: func_name '(' ')'
   * (Note that many of the special SQL functions wouldn't actually make any
   * sense as functional index entries, but we ignore that consideration here.)
   */
! func_expr: func_application filter_clause over_clause 
  				{
!               		FuncCall *n = (FuncCall*)$1;
! 					n->agg_filter = $2;
! 					n->over = $3;
! 					$$ = (Node*)n;
  				} 
  			| func_expr_common_subexpr
  				{ $$ = $1; }
--- 11202,11236 ----
   * (Note that many of the special SQL functions wouldn't actually make any
   * sense as functional index entries, but we ignore that consideration here.)
   */
! func_expr: func_application within_group_clause filter_clause over_clause 
  				{
!               		FuncCall *n = (FuncCall *) $1;
! 					/*
! 					 * the order clause for WITHIN GROUP and the one
! 					 * for aggregate ORDER BY share a field, so we
! 					 * have to check here that at most one is present.
! 					 * We check for DISTINCT here to give a better
! 					 * error position.  Other consistency checks are
! 					 * deferred to parse_func.c or parse_agg.c
! 					 */
! 					if ($2 != NIL)
! 					{
! 						if (n->agg_order != NIL)
! 							ereport(ERROR,
! 									(errcode(ERRCODE_SYNTAX_ERROR),
! 									 errmsg("Cannot have multiple ORDER BY clauses with WITHIN GROUP"),
! 									 parser_errposition(@2)));
! 						if (n->agg_distinct)
! 							ereport(ERROR,
! 									(errcode(ERRCODE_SYNTAX_ERROR),
! 									 errmsg("Cannot have DISTINCT and WITHIN GROUP together"),
! 									 parser_errposition(@2)));
! 						n->agg_order = $2;
! 						n->has_within_group = TRUE;
! 					}
! 					n->agg_filter = $3;
! 					n->over = $4;
! 					$$ = (Node *) n;
  				} 
  			| func_expr_common_subexpr
  				{ $$ = $1; }
***************
*** 12716,12721 **** unreserved_keyword:
--- 12789,12795 ----
  			| VIEW
  			| VOLATILE
  			| WHITESPACE_P
+ 			| WITHIN
  			| WITHOUT
  			| WORK
  			| WRAPPER
